#include <iostream>
#include <fstream>
#include <vector>
#include <array>
#include <algorithm>
using namespace std;

bool match(char x , char wanted, bool is_first) {
    if (is_first && x == 0)
        return false;
    return x == wanted || wanted == '*';
}

struct triplet {
  int a;
  int b;
  int r;
};

int main() {
    ifstream cin("puzzle.in");
    ofstream cout("puzzle.out");

    int T; cin >> T;
    while (T--) {
        string A, B, C; cin >> A >> B >> C;

        // A + B = C
        reverse(A.begin(), A.end());
        reverse(B.begin(), B.end());
        reverse(C.begin(), C.end());

        int N = A.size();
        int M = B.size();
        int K = C.size();

        vector<triplet> how[2];
        how[0] = how[1] = vector<triplet>(K, triplet{-1, -1, -1});

        array< array< array< array< array<triplet, 11>, 11>, 11>, 2>, 2> precalc_how;
        for (int r1 = 0; r1 < 2; ++r1)
            for (int r2 = 0; r2 < 2; ++r2)
                for (int a = 0; a <= 10; ++a)
                    for (int b = 0; b <= 10; ++b)
                        for (int c = 0; c <= 10; ++c) {
                            precalc_how[r1][r2][a][b][c] = triplet{-1, -1, -1};
                        }

        for (int remainder = 0; remainder < 2; ++remainder)
            for (int a = 0; a < 10; ++a)
                for (int b = 0; b < 10; ++b) {
                    int c = (remainder + a + b) % 10;
                    int new_rem = (remainder + a + b) / 10;
                    for (auto x : {a, 10})
                        for (auto y : {b, 10})
                            for (auto z : {c, 10}) {
                                precalc_how[remainder][new_rem][x][y][z] = triplet{a, b, remainder};
                            }
                }

        for (int i = 0; i < K; ++i) {
            if (i == N - 1 || i == M - 1 || i == K - 1) {
                int startA = 0, endA = 9, startB = 0, endB = 9;
                if (i >= N)
                startA = endA = 0;
                else if (A[i] != '*')
                startA = endA = A[i] - '0';

                if (i == N - 1)
                startA = max(startA, 1);

                if (i >= M)
                startB = endB = 0;
                else if (B[i] != '*')
                startB = endB = B[i] - '0';
                if (i == M - 1)
                startB = max(startB, 1);

                triplet prevhow[2] = {triplet{0, 0, 0}, triplet{-1, -1, -1}};

                if (i > 0) {
                    prevhow[0] = how[0][i - 1];
                    prevhow[1] = how[1][i - 1];
                }

                for (int a = startA; a <= endA; ++a)
                    for (int b = startB; b <= endB; ++b)
                        for (int remainder = 0; remainder < 2; ++remainder)
                            if (match((a + b + remainder) % 10 + '0', C[i], i == K - 1)) {
                                if (prevhow[remainder].r != -1)
                                    how[(a + b + remainder) / 10][i] = triplet{a, b, remainder};
                            }
            } else {
                // we have it all precalculated
                int a = 0;
                if (i < N) {
                    a = A[i] - '0';
                    if (A[i] == '*')
                        a = 10;
                }
                int b = 0;
                if (i < M) {
                    b = B[i] - '0';
                    if (B[i] == '*')
                        b = 10;
                }

                int c = C[i] - '0';
                if (C[i] == '*')
                    c = 10;

                triplet prevhow[2] = {triplet{0, 0, 0}, triplet{-1, -1, -1}};

                if (i > 0) {
                    prevhow[0] = how[0][i - 1];
                    prevhow[1] = how[1][i - 1];
                }

    
                for (int remainder = 0; remainder < 2; ++remainder)
                    for (int new_rem = 0; new_rem < 2; ++new_rem) {
                        if (precalc_how[remainder][new_rem][a][b][c].a != -1 && prevhow[remainder].a != -1)
                            how[new_rem][i] = precalc_how[remainder][new_rem][a][b][c];
                    }
            }
        }

        int remainder = 0;
        for (int i = K - 1; i >= 0; --i) {
            if (i < N)
                A[i] = how[remainder][i].a + '0';
            if (i < M)
                B[i] = how[remainder][i].b + '0';
            C[i] = (how[remainder][i].a + how[remainder][i].b + how[remainder][i].r) % 10 + '0';
            remainder = how[remainder][i].r;
        }

        reverse(A.begin(), A.end());
        reverse(B.begin(), B.end());
        reverse(C.begin(), C.end());
        cout << A << "\n" << B << "\n" << C << "\n";
    }
}
