/*Patrick Catalin Alexandru Sava
Atooom Industry and Resources SRL
University of Bucharest
Expected : 100 
O (N log N)
*/

#include <fstream>
#include <cassert>
#include <vector>
#include <unordered_map>
#include <algorithm>

using namespace std ;

ifstream cin ("taietura.in") ;
ofstream cout ("taietura.out") ;

const int MAX = 2e5 ;
const int VALMAX = 2e9 ;

int main(int argc, char const *argv[])
{
	int n ; 
	cin >> n ; 
	assert (n >= 1 and n <= MAX) ;
	vector <long long> sp (n + 1, 0) ;
	vector <int> v (n + 1, 0) ;
	for (int i = 1 ; i <= n ; ++ i) {
		cin >> v [i] ; 
		assert (-VALMAX <= v [i] and v [i] <= VALMAX) ;
		sp [i] = v [i] ;
		sp [i] += sp [i - 1] ;
	}
	sort (sp.begin(), sp.end()) ;
	unordered_map <long long, int> H ;
	int e = 1 ; 
	long long last = sp [0] ; 
	for (auto x: sp) {
		if (x == last) {
			H [x] = e ;
		}
		else {
			++ e ; 
			H [x] = e ;
			last = x ;
		}
	}
	sp [0] = 0 ;
	for (int i = 1 ; i <= n ; ++ i) {
		sp [i] = v [i] ;
		sp [i] += sp [i - 1] ;
	}
	vector <int> frecv (e + 1, 0) ;
	vector <int> dr (e + 1, 0) ;
	for (int i = 0; i <= n ; ++ i) {
		frecv [H[sp[i]]] += 1 ;
		dr [H[sp[i]]] += 1 ;
	}
	vector <long long> mars (n + 1, 0) ;
	for (int i = 0 ; i < n; ++ i) {
		dr [H[sp[i]]] -= 1 ;
		mars [i + 1] += dr [H[sp[i]]] ;
		mars [i + 1] -= frecv [H[sp[i]]] - dr [H[sp[i]]] - 1 ;  
	} 
	for (int i = 1 ; i <= n ; ++ i) {
		mars [i] += mars [i - 1] ; 
		cout << mars [i] << ' ' ;
	}
	return 0;
}