#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

int64_t area(pair<int, int> A, pair<int, int> B, pair<int, int> C) {
    return 1LL * A.first * (B.second - C.second) + 1LL * B.first * (C.second - A.second) + 1LL * C.first * (A.second - B.second);
}

int sign(int x) {
    if (x > 0)
        return 1;
    return -1;
}

int64_t partial_sum(int to) {
    return 1LL * to * (to + 1) / 2;
}

int64_t partial_sum(int from, int to) {
    return partial_sum(to) - partial_sum(from - 1);
}

int main() {
    ifstream cin("camp.in");
    ofstream cout("camp.out");

    int N; assert(cin >> N);
    assert(1 <= N && N <= 100 * 1000);

    vector< pair<int, int> > V(N);
    for (int i = 0; i < N; ++i) {
        assert(cin >> V[i].first >> V[i].second);
        assert(1 <= V[i].first && V[i].first <= 100 * 1000);
        assert(1 <= V[i].second && V[i].second <= 100 * 1000);
    }

    for (int i = 0; i < N; ++i)
        assert(area(V[i], V[(i + 1) % N], V[(i + 2) % N]) >= 0);

    int max_x = V[0].first;
    for (auto &p : V)
        max_x = max(max_x, p.first);

    vector< vector< pair<int, int> > > intersect(max_x + 1);
    for (int i = 0; i < N; ++i) {
        auto now = V[i];
        auto next = V[(i + 1) % N];
        if (now.first == next.first) {
            continue;
        }
        int from = now.first;
        int to = next.first;
        auto after_next = V[(i + 2) % N];
        if (next.first == after_next.first)
            to += sign(to - from);
        int anum = (now.second - next.second);
        int den = (now.first - next.first);
        int64_t bnum = (1LL * next.second * now.first - 1LL * now.second * next.first);

        if (den < 0) {
            anum *= -1;
            den *= -1;
            bnum *= -1;
        }

        for (int x = from; x != to; x += sign(to - from)) {
            int64_t ynum = 1LL * anum * x + bnum;
            assert(1 <= ynum / den && ynum / den <= 100 * 1000);
            if (ynum % den == 0) {
                intersect[x].emplace_back(ynum / den, ynum / den);
            } else {
                intersect[x].emplace_back(ynum / den, ynum / den + 1);
            }
        }
    }

    int64_t answer = 0;
    for (int i = 0; i <= max_x; ++i) {
        if (intersect[i].empty())
            continue;
        if (intersect[i].size() == 1) {
            assert(intersect[i][0].first == intersect[i][0].second);
            answer += i + intersect[i][0].first;
            continue;
        }

        assert(intersect[i].size() == 2);
        if (intersect[i][0] > intersect[i][1])
            swap(intersect[i][0], intersect[i][1]);
        int from = intersect[i][0].second;
        int to = intersect[i][1].first;
        answer += 1LL * i * (to - from + 1);
        answer += partial_sum(from, to);
    }

    cout << answer << "\n";
}
