#include <fstream>
#include <iostream>
#include <vector>

using namespace std;

struct Point {
    int x, y;
};

vector <Point> v;

inline long long sum(int n) {
    return 1ll * n * (n + 1) / 2;
}

bool InSegment(Point A, Point B, int x) {
    int minx = min(A.x, B.x);
    int maxx = A.x + B.x - minx;

    return (minx <= x && x <= maxx);
}

inline bool Vertical(Point A, Point B) {
    return A.x == B.x;
}

int intersect(int x, int &i, int sens) {
    while (!InSegment(v[i], v[i + 1], x) || Vertical(v[i], v[i + 1])) {
        i = i + sens;
        if (i == v.size() - 1)
            i = 0;
        if (i < 0)
            i = v.size() - 2;
    }

    int a = v[i].y - v[i + 1].y;
    int b = v[i + 1].x - v[i].x;
    long long c = 1ll * v[i].x * v[i + 1].y - 1ll * v[i].y * v[i + 1].x;

    double long y = (-1 * (double long)c - (double long)x * a) / b;
    if (sens > 0) {
        if ((y - (int)y) > 1e-14)
            return (int)(y + 1);
        return (int)y;
    }
    return (int)y;
}

int before(int i) {
    i--;
    if (i < 0)
        i = v.size() - 2;

    return i;
}

int main() {
    Point P;
    int n, x, y, i1, i2, left, right;

    ifstream cin("camp.in");
    ofstream cout("camp.out");

    cin >> n;

    int limx = 0;
    for (int i = 0; i < n; i++) {
        cin >> x >> y;
        P.x = x;
        P.y = y;
        v.push_back(P);
        limx = max(x, limx);
    }
    v.push_back(v[0]);

    x = 2e5 + 10;
    for (int i = 0; i < n; i++)
        if (v[i].x < x)
            x = v[i].x;

    i1 = i2 = -1;
    for (int i = 0; i < n; i++)
        if (v[i].x == x) {
            if (i1 == -1)
                i1 = before(i);
            else
                if (v[i].y > v[i1].y)
                    i1 = before(i);

            if (i2 == -1)
                i2 = i;
            else
                if (v[i].y < v[i2].y)
                    i2 = i;
        }

    long long ans = 0;
    for (int i = x; i <= limx; i++) {
        left = intersect(i, i2, 1);
        right = intersect(i, i1, -1);

//        cerr << left << " " << right << "\n";
        ans = ans + 1ll * i * (right - left + 1) + sum(right) - sum(left - 1);
    }

    cout << ans << "\n";

    return 0;
}
