/*Patrick Catalin Alexandru Sava
Atooom Industry and Resources SRL
University of Bucharest
Expected : 100*/

#include <fstream>
#include <cassert>
#include <cstring>
#include <stack>
#include <vector>

using namespace std ;

ifstream cin  ("identice.in") ;
ofstream cout ("identice.out") ;

const int MAX = 1e3 ;

long long compute (char mat[][MAX + 3], char target, int n) {
	vector <int> st (n + 1) ;
	vector <int> dr (n + 1) ; 
	vector <long long> ans (n + 1) ;
	stack <int> s ;
	vector <int> height (n + 2, 0) ;
	for (int i = 1 ; i <= n ; ++ i) {
		while (!s.empty()) {
			s.pop() ;
		}
		for (int j = 1 ; j <= n ; ++ j) {
			if (mat [i][j] == target) {
				height [j] += 1 ;
			}
			else {
				height [j] = 0 ;
			}
		}
		height [0] = -1 ;
		s.push (0) ;
		for (int j = 1 ; j <= n ; ++ j) {
			while (!s.empty() and height[s.top()] >= height[j]) {
				s.pop () ;
			}
			st [j] = s.top() ;
			s.push(j) ;
		}
		while (!s.empty()) {
			s.pop() ;
		}
		height [n + 1] = -1 ;
		s.push (n + 1) ;
		for (int j = n ; j >= 1 ; -- j) {
			while (!s.empty() and height[s.top()] > height[j]) {
				s.pop () ;
			}
			dr [j] = s.top() ;
			s.push(j) ;
		}
		for (int j = 1 ; j <= n ; ++ j) {
			ans [height[j]] += 1LL * (dr [j] - j) * (j - st [j]) ;
			// cout << "adun " << 1LL * (dr [j] - j) * (j - st [j]) << " pentru inaltimea " << height [j] << '\n';
		}
	}
	for (int j = n ; j >= 1; -- j) {
		ans [j - 1] += ans [j] ;
	}
	long long Sum = 0 ; 
	for (int j = n ; j >= 1; -- j) {
		Sum += ans [j] ; 
	}
	return Sum ;
}

long long Solve1 (char mat[][MAX + 3], int n) {
	return compute (mat, '0', n) + compute (mat, '1', n) ;
}

int ZET (char mat[][MAX + 3], int n, int d) {
	vector <int> *mars = new vector <int> [n + 4] ;
	for (int i = 0 ; i <= n + 3 ; ++ i) {
		mars [i].resize(n + 3) ;
	}
	int sol = 0 ; 
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= n ; ++ j) {
			mars [i][j] += mars [i - 1][j] ;
			mars [i][j] += mars [i][j - 1] ;
			mars [i][j] -= mars [i - 1][j - 1] ;
			if (mat [i][j] == '1' and mars [i][j] % 2 == 0) {
				if (i + d - 1 > n or j + d - 1 > n)
					return -1 ;
				mars [i][j] += 1 ;
				mars [i][j + d] -= 1 ;
				mars [i + d][j] -= 1 ;
				mars [i + d][j + d] += 1 ;
				sol += 1 ;
			}
			if (mat [i][j] == '0' and mars [i][j] % 2 == 1) {
				if (i + d - 1 > n or j + d - 1 > n)
					return -1 ;
				mars [i][j] += 1 ;
				mars [i][j + d] -= 1 ;
				mars [i + d][j] -= 1 ;
				mars [i + d][j + d] += 1 ;
				sol += 1 ;
			}
			// cout << mars [i][j] << ' ' ; 
		}
		// cout << '\n' ;
	}
	return sol ;
}

int Solve2 (char mat[][MAX + 3], int n, int dfixed) {
	int A = ZET (mat, n, dfixed) ;
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= n ; ++ j) {
			if (mat [i][j] == '0') {
				mat [i][j] = '1' ; 
			}
			else mat [i][j] = '0' ;
		}
	}
	// cout << "========================================\n" ;
	int B = ZET (mat, n, dfixed) ;
	if (A == -1 and B == -1) 
		return -1 ; 
	if (A == -1)
		return B ;
	if (B == -1)
		return A ;
	return min (A, B) ;
}

int main(int argc, char const *argv[])
{
	char mat [MAX + 3][MAX + 3] ;
	int tip ; 
	cin >> tip ; 
	int n, d;
	cin >> n >> d ; 
	assert (n >= 1 and n <= MAX) ;
	assert (d >= 1 and d <= MAX) ;
	for (int i = 1 ; i <= n ; ++ i) {
		cin >> (mat[i] + 1) ;
		assert (strlen (mat[i] + 1) == n) ;
	}
	if (tip == 1)
		cout << Solve1(mat, n) << '\n' ;
	else
		cout << Solve2(mat, n, d) << '\n' ;
	return 0;
}